; NASM source, use nasm -f elf to compile.
; low-level IRQ handlers
bits 32

extern ProcessIRQ

section .text

; ----- IRQ -------
; low level IRQ handlers which gather necessary CPU info and
; call high level procedures implemented in pascal.


%macro lowlevIRQhandler 1
; - irq number 0..15 as the argument.

global LowLev_IRQ%1_Handler
LowLev_IRQ%1_Handler:

  push ds
  push es
  pushad
; --------- 
  mov ax,16
  mov ds,ax
  mov es,ax
 
  mov ebp,esp
  add ebp,4+4+(8*4) ; skip effects of push ds,es,pushad
 
; ----------
; // stack frame
; // 
; // (EBP+0) -> EIP
; // (EBP+4) -> CS
; // (EBP+8) -> EFLAGS
; ///////
; // if VM flag is set in (EBP+6):
; ///////
; // (EBP+12) -> ESP
; // (EBP+16) -> SS
; // (EBP+20) -> ES
; // (EBP+24) -> DS
; // (EBP+28) -> FS
; // (EBP+32) -> GS
; //////////
; see TZeroRingStackFrame in pmode.pas
 
;  mov eax,%1 ; IRQ number
  
  push ebp  ; pointer to the stack frame generated by the INT
 ; push eax
  push dword %1
  call ProcessIRQ
 
 
; ---------
  popad
  pop es
  pop ds
  iret
 
%endmacro


%assign prp_i 0
%rep 16

lowlevIRQhandler prp_i

%assign prp_i prp_i+1
%endrep