{$ASMMODE intel}
unit kutils;
interface
uses gentypes;

  procedure KU_DispStr( offs:DWord;
                        p_s:PChar );

  procedure KU_OutP( portn:Word;
                     b:Byte ); stdcall;

  function KU_InP( portn:Word ):Byte; stdcall;

  procedure KU_OutPW( portn:Word;
                      w:Word ); stdcall;

  function KU_InPW( portn:Word ):Word; stdcall;

  procedure KU_ScrollScr; stdcall;

  
  // TODO: !!!
  
  procedure KU_PrintLn( p_s:PChar );
  
  procedure KU_Print( p_s:PChar );
  
  procedure KU_PrintUInt( i:TUInt );
  
  procedure KU_PrintHex( i:TUInt );
  
  

implementation
uses strings;
var cx:Byte; // cursor position
  
  procedure KU_PrintUInt( i:TUInt );
  var s:string[12];
  begin
    Str( i, s );
    s[Length(s)+1]:=#0;
    KU_Print( @s[1] );
  end;
  
  procedure KU_PrintHex( i:TUInt );
  var s:String[12];
      z:Byte;
      c:Char;
      prevzero:Boolean;
      
      
    function getn4( n:TUInt ):Char;
    var b:Byte;
    begin
      b:=( i shr (4*n) ) and $F;
      case b of
      0..9: getn4:=Chr( Ord('0')+b );
      $A..$F: getn4:=Chr( Ord('A')+b-$A );
      else
       getn4:='X'; // error ?
      end; // case
      
    end; // getn4
      
  begin // KU_PrintHex
  
    s:='';
    prevzero:=true; // do previous values matter?
  
    // from high to low    
    for z:=7 downto 0 do
    begin
      c:=getn4( z );
      
      if c<>'0' then 
      begin
        prevzero:=false;
        s:=s+c;
      end
        else // c='0'
          begin
            if (not prevzero) then s:=s+c
             else
               if z<=1 then s:=s+c;      
          end; // else c='0'
              
    end; // for z
  
    s[Length(s)+1]:=#0;
    KU_Print( @s[1] );
  end; // KU_PrintHex



  procedure KU_ScrollScr; stdcall; assembler;
  asm
    mov esi,$B8000+160
    mov edi,$B8000
    mov ecx,24*40
    cld
    rep movsd
    mov edi,$B8000+160*24
    mov ecx,40
    mov eax,$0F200F20
    rep stosd
  end ['ESI','EDI','ECX','EAX'];
  
  
  procedure KU_Print( p_s:PChar );
  begin
    KU_DispStr( cx*2+160*24, p_s );
    cx:=cx+StrLen(p_s);  
  end;
  
  procedure KU_PrintLn( p_s:PChar );
  begin
    KU_Print( p_s );
    KU_ScrollScr;
    cx:=0;
  end;
  
  
  procedure KU_DispStr( offs:DWord;
                        p_s:PChar);
  var p:PChar;
      i:TUInt;
  begin
    i:=0;
    p:=PChar($B8000+offs);
    while p_s[i]<>#0 do
    begin
      p^:=p_s[i];
      Inc(p,2);
      Inc(i);
      if TPtrUInt(p) >= ($B8000+80*25*2) then
      begin
        KU_ScrollScr;
        cx:=0;
        p:=PChar($B8000+160*24);
      end;
      
    end; // while
  end;
  

  procedure KU_OutP( portn:Word;
                     b:Byte ); stdcall; assembler;
  asm
   mov al,b
   mov dx,portn
   out dx,al
  end ['EAX', 'EDX'];
  
  
  function KU_InP( portn:Word ):Byte; stdcall; assembler;
  asm
   mov eax,0
   mov dx,portn
   in al,dx
  end ['EAX', 'EDX'];
  
  
  procedure KU_OutPW( portn:Word;
                      w:Word ); stdcall; assembler;

  asm
   mov ax,w
   mov dx,portn
   out dx,ax
  end ['EAX', 'EDX'];

  
  function KU_InPW( portn:Word ):Word; stdcall; assembler;
  asm
   mov eax,0
   mov dx,portn
   in ax,dx
  end ['EAX', 'EDX'];

  
// UNIT INITIALIZATION

begin
  cx:=0; // set cursor position

end.
