{$I sd_vm86h.inc}

procedure kexception(excnum:Byte; trval:Word); // exception or INTerrupt (IRQ) number
var
    p_op:PByte;
    i:TUInt;
    
begin

  (*
     All exceptions caused by running V86 task are sent to
     specialized v86 exception handler and are not processed here.
  *)
  
  // TODO: - math exception handler, save/restore FPU context...
  //       - custom exception handlers table (for user programs etc.)


  if (gExcTSS[excnum].t_link=VM_TSS_DESC_N*8) 
  then 
  begin
    handle_vm86(excnum); // handle via V86 monitor
    exit;
  end;

  KU_Print('Exception $');
  KU_PrintHex(excnum);
  
  KU_PrintLn(' At CS:EIP (hex)=');
  KU_PrintHex(gSysTSS.cs);
  KU_Print(':');
  KU_PrintHex(gSysTSS.eip);
  
  KU_PrintLn('');
  
  
  p_op:=Pointer(gSysTSS.eip);
  
  KU_Print('Opcodes (hex)= ');

  for i:=1 to 8 do
  begin
    KU_PrintHex(p_op^);
    KU_Print(' ');
    Inc(p_op);
  end;

  KU_PrintLn('');
  
  KU_Print('EFLAGS=$');
  KU_PrintHex(gSysTSS.eflags);
    
  asm 
    cli
    hlt
  end;

  // HALT.
  
  
end; // kexception



// -----------------------------------------------
// Generic exception handler - TSS main code
// -----------------------------------------------
procedure ExcHandler; external name 'ExcHandler';
{$L irqexc_a.o}