unit sdconsts;
interface

const 
  SDVERSTR='SD-32 branch C, (c) 2001-2004 Yury Benesh';
  SDCONTACTSTR='http://stormdos.sourceforge.net, e-mail: ybxsoft@tut.by';
  SDGPLSTR='Covered by GNU General Public License v2.';



  IRQHANDLERS_MAXCOUNT=10; // see sdintr.pas - maximum count of handlers in chain
  EXCHANDLERS_MAXCOUNT=10; // see sdexcep.pas



  VM_TSS_DESC_N= 5;
  SYS_TSS_DESC_N= VM_TSS_DESC_N+1; // kernel/user TSS
  
  
  EXC_TSS_DESC_N=USER_TSS_DESC_N+USER_TSS_COUNT;
  
  EXCEPTIONS_COUNT=32;
  IRQ_COUNT=16;
  SYS_INT_N=$40; // also change in sd32_sdk.pas
  IDTDESC_COUNT=EXCEPTIONS_COUNT+IRQ_COUNT+(SYS_INT_N-EXCEPTIONS_COUNT-IRQ_COUNT)+1;
  


  GDTDESC_COUNT=1+2+2+1+1+EXCEPTIONS_COUNT;
  // GDT decriptors for NULL, CS0, DS0, CS3, DS3, VM_TSS_DESC, SYS_TSS_DESC
  // CS3 and DS3 are reserved
  // 8,16 - CS0/DS0
  // 24,32 - CS3/DS3 - (reserved for future)
  
 
  EXC_STACK_SZ=16384; // 16KiB for exc. stacks
  R0_STACK_SZ=8192; // 8KiB for Ring0 switch stack (R3->R0)
   // - used to allocate ss0:esp0 stack for VM86 TSS
   // - and kernel stack (for ISR/IRQ)
  
  /////
  
  
  VM86_INTARG=$F5; // INT argument which must cause VM86 termination
  
  
  // See chapter 5.3 of Intel Manual Vol. 3 for the following:
  
  EXCEPTION_GP=13; // General Protection - Fault - with error code
  EXCEPTION_DE=0; // Divide Error - Fault - no error code - caused by DIV/IDIV
  EXCEPTION_NM=7; // Device Not Available (No Math Copr.) - Fault - no error - FPU or WAIT/FWAIT
    // - see CLTS instruction, TS, MP flags of CR0
  
  
  EXCEPTION_MF=16; // FPU Error (Math Fault) - Fault - No error - FPU or WAIT/FWAIT
  
  
  


implementation
end.